'#####################################
'# Inteligentny TERMOSTAT
'#####################################
'Wersja kompilatora BASCOM-AVR v.1.11.7.4
'ProgramatorBASCOM-AVR v.1.11.7.4 STK200\STK300
'Generator zewnetrzny 8MHz (external)
'Fusebit A987 1110:1110 external OSC
'Reset wewnetrzny
'Fusebit KL 10 : 6CK 64mS Delay
$regfile = "M8DEF.DAT"
$crystal = 8000000
Config Timer1 = Timer , Prescale = 8
Config Adc = Single , Prescaler = 16 , Reference = Avcc
'Config Pinc.6 = Output
Config Pinb.3 = Output
Config Pinb.2 = Output
Config Pinb.1 = Output
Config Pinc.4 = Output
Config Pinb.0 = Output
Config Pind.0 = Output
Config Pind.1 = Output
Config Pind.2 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Output
Config Pind.7 = Output
Config Pinc.3 = Input
Config Pinc.2 = Input
Config Pinb.5 = Output
Config Pinc.5 = Output
Config Pinb.4 = Input
Config Pinc.0 = Input
Config Pinc.1 = Input
'#####################################
Clock Alias Portc.5
A1 Alias Portb.3
A2 Alias Portb.2
A3 Alias Portb.1
A4 Alias Portc.4
A5 Alias Portb.0
A_segm Alias Portd.7
B_segm Alias Portd.6
C_segm Alias Portd.2
D_segm Alias Portd.3
E_segm Alias Portd.5
F_segm Alias Portd.0
G_segm Alias Portd.4
H_segm Alias Portd.1
Led1 Alias Portd.7
Led2 Alias Portd.4
Led3 Alias Portd.0
Led4 Alias Portd.2
Led5 Alias Portd.5
Led6 Alias Portd.3
Led7 Alias Portd.6
Pk1 Alias Portb.5
Segm Alias Portd
Dim Flags As Byte
Midnight Alias Flags.0
Pk1_state Alias Flags.1
Ch_time Alias Flags.2
Active Alias Flags.3
Statkey Alias Flags.4
Working Alias Flags.5
Sign Alias Flags.6
'staa warto skoku przetwornika
'5V /1024 bity pomnoona
'dla unikniecia przecinkw
Const Skok = 4883
'wartoci portu segmentw
Const Dot = 2
Const X_d = 10
Const Minus = 11
Const X_st = 12
Const X_c = 13
Const X_e = 14
Const X_r = 15
Const X_h = 16
Const X_m = 17
Const X_t = 18
Const X_i = 19
Const X_o = 20
Const Empty = 100
Dim Wsk1 As Byte
Dim Wsk2 As Byte
Dim Wsk3 As Byte
Dim Wsk4 As Byte
Dim Wsk5 As Byte
Dim S_s As Byte
Dim M_m As Byte
Dim H_h As Byte
Dim D_o_w As Byte
Dim Degs As Integer
Dim X_h_h As Byte
Dim X_m_m As Byte
Dim Set_d_o_w As Byte
Dim H_on As Byte
Dim M_on As Byte
Dim H_off As Byte
Dim M_off As Byte
Dim T_off As Word
Dim Degs_off As Byte
Dim Temp As Long
Dim Temp_time As Long
Dim Temp_degs As Long
Dim Temp_word As Word
Dim Degs_temp As Integer
Dim Status As Byte
Dim Stat_licz As Byte
'typ edycji
Dim Isedit As Byte

'obsuga przetwornikw ADC
Dim Adc_key As Word
Dim Adc_temp As Word
Dim Adc_buf As Word
Dim Adc_licz As Word
'obsuga pamici EEPROM
Dim X_adress As Word
Dim X_byte As Byte
Dim Byte_hi As Byte
Dim Byte_lo As Byte
'zmienne dla TIMERA
Dim Sekundy As Long
Dim Count_time As Byte
Dim Fuse As Word
Dim Fuse_hi As Byte
Dim Fuse_lo As Byte
'#####################################
Declare Sub Degs2temp()
Declare Sub Temp2degs()
Declare Sub Set_char()
Dim Char As Byte
Dim Key As Byte
Declare Sub Get_eeproom()
Declare Sub Set_eeproom()
Declare Sub Convert_temp()
'#####################################
Start Adc
'#####################################
On Timer1 Timer_1_sub
Enable Interrupts
Disable Int0
Disable Int1
Disable Timer0
Enable Timer1
Stop Timer0
Stop Timer1
'#####################################
'Wait 1
'#####################################
Pk1_state = 0
Pk1 = 0
A1 = 0
A2 = 0
A3 = 0
A4 = 0
A5 = 0
Wsk1 = 255
Wsk2 = 255
Wsk3 = 255
Wsk4 = 255
Wsk5 = 255
'#####################################
Status = 0
Statkey = 0
Active = 0
Isedit = 0
Stat_licz = 0
Adc_licz = 1
Adc_buf = 0
Temp_word = 0
Midnight = 1
D_o_w = 7
Set_d_o_w = 7
Waitms 255
'#####################################
'odczyt stanu urzdzenia
Readeeprom X_byte , 9
Select Case X_byte
Case 0 : Working = 0
Case 1 : Working = 1
Case Else
Working = 1
X_byte = 1
Writeeeprom X_byte , 9
End Select
'#####################################
'pocztkowe ustawienia TIMER1
Sekundy = 43200
Fuse = 17215
Fuse_hi = 256 - High(fuse)
Fuse_lo = 256 - Low(fuse)
Count_time = 16
Tcnt1h = Fuse_hi
Tcnt1l = Fuse_lo
Start Timer1
'#####################################
Do
Incr Stat_licz
If Midnight = 1 Then
Midnight = 0
Incr D_o_w
If D_o_w > 7 Then D_o_w = 1
Set_d_o_w = D_o_w
Call Get_eeproom()
End If
'#####################################
'Obsuga wskanika nr 1
A1 = 1
A2 = 0
A3 = 0
A4 = 0
A5 = 0
Segm = Wsk1
Waitms 3
A1 = 0
Segm = 255
Waitus 200
'#####################################
'pierwsza cz zamiany sekund
'na godziny i minuty
Temp_degs = Sekundy
Temp_time = Temp_degs
'#####################################
'#####################################
'Obsuga wskanika nr 2
A1 = 0
A2 = 1
A3 = 0
A4 = 0
A5 = 0
Segm = Wsk2
Waitms 3
A2 = 0
Segm = 255
Waitus 200
'#####################################
'druga cz zamiany sekund na
'godziny i minuty
Temp = Temp_degs Mod 60
S_s = Temp
'#####################################
'Obsuga wskanika nr 3
A1 = 0
A2 = 0
A3 = 1
A4 = 0
A5 = 0
Segm = Wsk3
Waitms 3
A3 = 0
Segm = 255
Waitus 200
'#####################################
'trzecia cz zamiany sekund
'na godziny i minuty
Temp = Temp_degs / 60
Temp_degs = Temp / 60
'#####################################
'Obsuga wskanika nr 4
A1 = 0
A2 = 0
A3 = 0
A4 = 1
A5 = 0
Segm = Wsk4
Waitms 4
A4 = 0
Segm = 255
Waitus 200
'#####################################
'czwarta cz zamiany sekund na
'godziny i minuty
H_h = Temp_degs
Temp_degs = Temp Mod 60
M_m = Temp_degs
'#####################################
'Obsuga wskanika nr 5
A1 = 0
A2 = 0
A3 = 0
A4 = 0
A5 = 1
Segm = Wsk5
Waitms 4
A5 = 0
Segm = 255
Waitus 200
'#####################################
'Obsuga przetrwornika nr 2
'#####################################
Adc_temp = Getadc(2)
Adc_buf = Adc_buf + Adc_temp
If Adc_licz = 20 Then
Temp_word = Adc_buf / 20
Temp_degs = Temp_word
Call Degs2temp()
Adc_licz = 0
Adc_buf = 0
End If
Incr Adc_licz
'#####################################
'controla czasu wczenia obsugi
'grzania (Active = 1]
If Active = 0 Then
If H_on = H_h Then
If M_on = M_m Then
Active = 1
End If
End If
End If
'#####################################
'kontrola czasu wyczenia obsugi
'grzania [Active = 0]
If Working = 1 Then
If Active = 1 Then
If H_off = H_h Then
If M_off = M_m Then
Active = 0
Pk1_state = 0
End If
End If
End If
'#####################################
'jeeli aktywny to
If Active = 1 Then
'jeeli temperatura nisza ni
'zadana to
If Degs < Degs_off Then
Pk1_state = 1
Elseif Degs > Degs_off Then
'Jeeli Temperatura wysza ni
'zadana lub rwna to
Pk1_state = 0
End If
End If
'#####################################
End If
Pk1 = Pk1_state
'#####################################
'Obsuga przetwornika nr 3
Adc_key = Getadc(3)
'#####################################
'wylicza warto dla
'poszczeglnych znakw
Select Case Status
Case 0 :
Char = H_h / 10
Call Set_char()
Wsk1 = Char
Char = H_h Mod 10
Call Set_char()
Wsk2 = Char - Dot
Char = M_m / 10
Call Set_char()
Wsk3 = Char
Char = M_m Mod 10
Call Set_char()
Wsk4 = Char
If Active = 1 Then Wsk4 = Char - Dot
Case 1 :
If Working = 1 Then
If Sign = 1 Then
Char = Minus
Else
Char = Empty
End If
Call Set_char()
Wsk1 = Char
If Degs > 99 Then
Char = X_e
Elseif Degs > 10 And Sign = 1 Then
Char = X_e
Else
Char = Degs / 10
End If
Call Set_char()
Wsk2 = Char
If Degs > 99 Then
Char = X_r
Elseif Degs > 10 And Sign = 1 Then
Char = X_r
Else
Char = Degs Mod 10
End If
Call Set_char()
Wsk3 = Char
Char = X_c
Call Set_char()
Wsk4 = Char
Else
Char = Minus
Call Set_char()
Wsk1 = Char
Char = Minus
Call Set_char()
Wsk2 = Char
Char = Minus
Call Set_char()
Wsk3 = Char
Char = Minus
Call Set_char()
Wsk4 = Char
End If
If Pk1_state = 1 Then Wsk4 = Char - Dot
Case 10 :
Char = X_h
Call Set_char()
Wsk1 = Char
Char = X_i
Call Set_char()
Wsk2 = Char - Dot
Char = H_on / 10
Call Set_char()
Wsk3 = Char
Char = H_on Mod 10
Call Set_char()
Wsk4 = Char
Case 11 :
Char = X_m
Call Set_char()
Wsk1 = Char
Char = X_i
Call Set_char()
Wsk2 = Char - Dot
Char = M_on / 10
Call Set_char()
Wsk3 = Char
Char = M_on Mod 10
Call Set_char()
Wsk4 = Char
Case 12 :
Char = X_h
Call Set_char()
Wsk1 = Char
Char = X_o
Call Set_char()
Wsk2 = Char - Dot
Char = H_off / 10
Call Set_char()
Wsk3 = Char
Char = H_off Mod 10
Call Set_char()
Wsk4 = Char
Case 13 :
Char = X_m
Call Set_char()
Wsk1 = Char
Char = X_o
Call Set_char()
Wsk2 = Char
Char = M_off / 10
Call Set_char()
Wsk3 = Char
Char = M_off Mod 10
Call Set_char()
Wsk4 = Char
Case 14 :
Char = X_t
Call Set_char()
Wsk1 = Char
Char = Empty
Call Set_char()
Wsk2 = Char
Char = Degs_off / 10
Call Set_char()
Wsk3 = Char
Char = Degs_off Mod 10
Call Set_char()
Wsk4 = Char
Case 15 :
Char = X_d
Call Set_char()
Wsk1 = Char
Char = Empty
Call Set_char()
Wsk2 = Char
Char = Empty
Call Set_char()
Wsk3 = Char
Char = Set_d_o_w
Call Set_char()
Wsk4 = Char
Case 16 :
Char = X_h
Call Set_char()
Wsk1 = Char
Char = Empty
Call Set_char()
Wsk2 = Char
Char = X_h_h / 10
Call Set_char()
Wsk3 = Char
Char = X_h_h Mod 10
Call Set_char()
Wsk4 = Char
Case 17 :
Char = X_m
Call Set_char()
Wsk1 = Char
Char = Empty
Call Set_char() :
Wsk2 = Char
Char = X_m_m / 10
Call Set_char()
Wsk3 = Char
Char = X_m_m Mod 10
Call Set_char()
Wsk4 = Char
End Select
'#####################################
If Stat_licz > 120 Then
Stat_licz = 0
If Status = 0 Then
Status = 1
Elseif Status = 1 Then
Status = 0
End If
End If
'#####################################
If Isedit = 0 Then
Char = D_o_w + 20
Elseif Isedit = 2 Then
Char = Set_d_o_w + 20
Else
Char = Set_d_o_w + 30
End If
Call Set_char()
Wsk5 = Char
'#####################################
'sprawdza warto klawisza
Select Case Adc_key
Case 758 To 881 :
Key = 1
Case 553 To 676 :
Key = 2
Case 348 To 471 :
Key = 3
Case 143 To 266 :
Key = 4
Case 0 To 61 :
Key = 5
Case Else
Key = 0
End Select
If Statkey = 1 Then Key = 0
If Statkey = 0 Then
Statkey = 1
If Isedit <> 2 Then
If Key = 5 Then
If Isedit = 0 Then
Isedit = 1
Set_d_o_w = 1
Call Get_eeproom()
Status = 10
Elseif Isedit = 1 Then
Isedit = 0
Call Set_eeproom()
Status = 0
End If
End If
End If
'#####################################
If Isedit = 0 Then
Select Case Key
Case 1 :
Isedit = 2
Status = 15
X_h_h = H_h
X_m_m = M_m
Set_d_o_w = D_o_w
Ch_time = 0
Case 2 :
If Working = 1 Then
Working = 0
X_byte = 0
Elseif Working = 0 Then
Working = 1
X_byte = 1
End If
Writeeeprom X_byte , 9
Case 3 : Pk1_state = 0
Case 4 : Pk1_state = 1
End Select
Elseif Isedit = 2 Then
'#####################################
Select Case Key
Case 1 :
Isedit = 0
Status = 0
Case 2 :
Incr Status
If Status > 17 Then Status = 15
Ch_time = 1
Case 3 :
Select Case Status
Case 15 :
Decr Set_d_o_w
If Set_d_o_w < 1 Then Set_d_o_w = 7
Case 16 :
Decr X_h_h
If X_h_h > 23 Then X_h_h = 23
Case 17 :
Decr X_m_m
If X_m_m > 59 Then X_m_m = 59
End Select
Ch_time = 1
Case 4 :
Select Case Status
Case 15 :
Incr Set_d_o_w
If Set_d_o_w > 7 Then Set_d_o_w = 1
Case 16 :
Incr X_h_h
If X_h_h > 23 Then X_h_h = 0
Case 17 :
Incr X_m_m
If X_m_m > 59 Then X_m_m = 0
End Select
Ch_time = 1
Case 5 :
If Ch_time = 1 Then
Temp_degs = X_h_h * 60
Temp_degs = Temp_degs + X_m_m
Temp_degs = Temp_degs * 60
Sekundy = Temp_degs
D_o_w = Set_d_o_w
End If
Isedit = 0
Status = 0
Set_d_o_w = D_o_w
Call Get_eeproom()
End Select
'#####################################
Elseif Isedit = 1 Then
Select Case Key
Case 1 :
Call Set_eeproom()
Incr Set_d_o_w
If Set_d_o_w > 7 Then Set_d_o_w = 1
Status = 10
Call Get_eeproom()
Case 2 :
Incr Status
If Status > 14 Then Status = 10
Case 3 :
Select Case Status
Case 10 :
Decr H_on
If H_on > 23 Then H_on = 23
Case 11 :
Decr M_on
If M_on > 59 Then M_on = 59
Case 12 :
Decr H_off
If H_off > 23 Then H_off = 23
Case 13 :
Decr M_off
If M_off > 59 Then M_off = 59
Case 14 :
Decr Degs_off
If Degs_off > 99 Then Degs_off = 99
End Select
Case 4 :
Select Case Status
Case 10 :
Incr H_on
If H_on > 23 Then H_on = 0
Case 11 :
Incr M_on
If M_on > 59 Then M_on = 0
Case 12 :
Incr H_off
If H_off > 23 Then H_off = 0
Case 13 :
Incr M_off
If M_off > 59 Then M_off = 0
Case 14 :
Incr Degs_off
If Degs_off > 99 Then Degs_off = 0
End Select
End Select
End If
End If
'#####################################
'puapka na klawisze
Adc_key = Getadc(3)
If Adc_key > 900 Then
Statkey = 0
Else
Statkey = 1
End If
'#####################################
Loop
'#####################################
Sub Degs2temp()
Temp_degs = Temp_degs * Skok
Temp_degs = Temp_degs / 10
Temp_degs = Temp_degs / 10
Temp_degs = Temp_degs / 10
Temp_degs = Temp_degs / 10
Degs_temp = Temp_degs - 273
If Degs_temp < 0 Then
Sign = 1
Else
Sign = 0
End If
Degs = Abs(degs_temp)
End Sub
'#####################################
Sub Temp2degs()
Temp_degs = Degs_off + 273
Temp_degs = Temp_degs * 10
Temp_degs = Temp_degs * 10
Temp_degs = Temp_degs * 10
Temp_degs = Temp_degs * 10
Temp_degs = Temp_degs / Skok
T_off = Temp_degs
Incr T_off
End Sub
'#####################################
Sub Set_char()
Select Case Char
'Cyfry
Case 0 : Char = 18                                          '[ 0 ]
Case 1 : Char = 187                                         'I 1 ]
Case 2 : Char = 7                                           '[ 2 ]
Case 3 : Char = 35                                          '[ 3 ]
Case 4 : Char = 170                                         '[ 4 ]
Case 5 : Char = 98                                          '[ 5 ]
Case 6 : Char = 66                                          '[ 6 ]
Case 7 : Char = 59                                          '[ 7 ]
Case 8 : Char = 2                                           '[ 8 ]
Case 9 : Char = 34                                          '[ 9 ]
'litery
Case 10 : Char = 131                                        '[ d ]
Case 11 : Char = 239                                        '[ - ]
Case 12 : Char = 46                                         '[ St. ]
Case 13 : Char = 86                                         '[ C ]
Case 14 : Char = 70                                         '[ e ]
Case 15 : Char = 207                                        '[ r ]
Case 16 : Char = 202                                        '[ h ]
Case 17 : Char = 203                                        '[ n ]
Case 18 : Char = 198                                        '[ t ]
Case 19 : Char = 251                                        '[ i ]
Case 20 : Char = 195                                        '[ o ]
'ledy w pozytywie
Case 21 : Char = 127                                        '[ +Pon ]
Case 22 : Char = 239                                        '[ +Wt ]
Case 23 : Char = 254                                        '[ +Sr ]
Case 24 : Char = 251                                        '[ +Czw ]
Case 25 : Char = 223                                        '[ +Pi ]
Case 26 : Char = 247                                        '[ +So ]
Case 27 : Char = 191                                        '[ +Nie ]
'ledy w negatywie
Case 31 : Char = 128                                        '[ -Pon ]
Case 32 : Char = 16                                         '[ -Wt ]
Case 33 : Char = 1                                          '[ -Sr ]
Case 34 : Char = 4                                          '[ -Czw ]
Case 35 : Char = 32                                         '[ -Pi ]
Case 36 : Char = 8                                          '[ -So ]
Case 37 : Char = 64                                         '[ -Nie ]
Case 100 : Char = 255                                       '[ "" ]
End Select
End Sub
'#####################################
Sub Get_eeproom()
X_adress = Set_d_o_w * 10
Readeeprom Byte_hi , X_adress
Incr X_adress
Readeeprom Byte_lo , X_adress
T_off = Byte_hi * 256
T_off = T_off + Byte_lo
If T_off > 765 Or T_off < 550 Then
T_off = 662
Byte_hi = 2
Byte_lo = 150
Writeeeprom Byte_lo , X_adress
Decr X_adress
Writeeeprom Byte_hi , X_adress
Incr X_adress
End If
Temp_degs = T_off
Call Degs2temp()
Degs_off = Degs
Incr X_adress
Readeeprom H_on , X_adress
If H_on > 23 Then
H_on = 12
Writeeeprom H_on , X_adress
End If
Incr X_adress
Readeeprom M_on , X_adress
If M_on > 59 Then
M_on = 30
Writeeeprom M_on , X_adress
End If
Incr X_adress
Readeeprom H_off , X_adress
If H_off > 23 Then
H_off = 12
Writeeeprom H_off , X_adress
End If
Incr X_adress
Readeeprom M_off , X_adress
If M_off > 59 Then
M_off = 45
Writeeeprom M_off , X_adress
End If
End Sub
'#####################################
Sub Set_eeproom()
Call Temp2degs()
Byte_hi = High(t_off)
Byte_lo = Low(t_off)
X_adress = Set_d_o_w * 10
Readeeprom X_byte , X_adress
If X_byte <> Byte_hi Then
Writeeeprom Byte_hi , X_adress
End If
Incr X_adress
Readeeprom X_byte , X_adress
If X_byte <> Byte_lo Then
Writeeeprom Byte_lo , X_adress
End If
Incr X_adress
Readeeprom X_byte , X_adress
If X_byte <> H_on Then
Writeeeprom H_on , X_adress
End If
Incr X_adress
Readeeprom X_byte , X_adress
If X_byte <> M_on Then
Writeeeprom M_on , X_adress
End If
Incr X_adress
Readeeprom X_byte , X_adress
If X_byte <> H_off Then
Writeeeprom H_off , X_adress
End If
Incr X_adress
Readeeprom X_byte , X_adress
If X_byte <> M_off Then
Writeeeprom M_off , X_adress
End If
End Sub
'#####################################
Timer_1_sub:
Decr Count_time
If Count_time > 0 Then Goto No_1sek
Count_time = 16
Tcnt1h = Fuse_hi
Tcnt1l = Fuse_lo
Toggle Clock
Incr Sekundy
If Sekundy > 86399 Then
Sekundy = 0
Midnight = 1
End If
No_1sek:
Return
'#####################################
End